DBG_CONTINUE                         equ  00010002h
DBG_EXCEPTION_NOT_HANDLED            equ  80010001h
DEBUG_PROCESS                        equ  1h
DEBUG_ONLY_THIS_PROCESS              equ  2h
EXCEPTION_DEBUG_EVENT                equ  1
CREATE_THREAD_DEBUG_EVENT            equ  2
CREATE_PROCESS_DEBUG_EVENT           equ  3
EXIT_THREAD_DEBUG_EVENT              equ  4
EXIT_PROCESS_DEBUG_EVENT             equ  5
LOAD_DLL_DEBUG_EVENT                 equ  6
UNLOAD_DLL_DEBUG_EVENT               equ  7
OUTPUT_DEBUG_STRING_EVENT            equ  8
RIP_EVENT                            equ  9

PROCESS_INFORMATION	struct
       pi_hProcess          dd	  ?		;process handle
       pi_hThread           dd	  ?		;thread handle
       pi_dwProcessId       dd	  ?		;process id
       pi_dwThreadId        dd	  ?		;thread id
PROCESS_INFORMATION	ends


STARTUPINFO		struct
       si_cb                dd	  ?		;structure size
       si_lpReserved        dd	  ?		;(reserved)
       si_lpDesktop         dd	  ?		;desktop name
       sl_lpTitle           dd	  ?		;console window title
       si_dwX               dd	  ?		;window origin (column)
       si_dwY               dd	  ?		;window origin (row)
       si_dwXSize           dd	  ?		;window width
       si_dwYSize           dd	  ?		;window height
       si_dwXCountChars     dd	  ?		;screen buffer width
       si_dwYCountChars     dd	  ?		;screen buffer height
       si_dwFillAttribute   dd	  ?		;console window initialization
       si_dwFlags           dd	  ?		;structure member flags
       si_wShowWindow       dw	  ?		;ShowWindow() parameter
       si_cbReserved2       dw	  ?		;(reserved)
       si_lpReserved3       dd	  ?		;(reserved)
       si_hStdInput         dd	  ?		;standard input handle
       si_hStdOutput        dd	  ?		;standard output handle
       si_hStdError         dd	  ?		;standard error handle
STARTUPINFO		ends 

LDT_ENTRY STRUCT
         ldt_LimitLow       dw     ?
         ldt_BaseLow        dw     ?
         ldt_BaseMid        db     ?
         ldt_Flags1         db     ?
         ldt_Flags2         db     ?
         ldt_BaseHi         db     ?
LDT_ENTRY ENDS        

EXCEPTION_DEBUG_INFO STRUCT
  EDI_ExceptionRecord  EXCEPTION_RECORD <>
  EDI_FirstChance      dd      ?
EXCEPTION_DEBUG_INFO ENDS

CREATE_THREAD_DEBUG_INFO STRUCT
  CTDI_hThread               DWORD      ?
  CTDI_lpThreadLocalBase     DWORD      ?
  CTDI_lpStartAddress        DWORD      ?
CREATE_THREAD_DEBUG_INFO ENDS

EXIT_THREAD_DEBUG_INFO STRUCT
  ETD_ExitCode  DWORD      ?
EXIT_THREAD_DEBUG_INFO ENDS

EXIT_PROCESS_DEBUG_INFO STRUCT
  EPD_ExitCode  DWORD      ?
EXIT_PROCESS_DEBUG_INFO ENDS

LOAD_DLL_DEBUG_INFO STRUCT
  LDD_hFile                     DWORD      ?
  LDD_lpBaseOfDll               DWORD      ?
  LDD_dwDebugInfoFileOffset     DWORD      ?
  LDD_nDebugInfoSize            DWORD      ?
  LDD_lpImageName               DWORD      ?
  LDD_fUnicode                  WORD       ?
LOAD_DLL_DEBUG_INFO ENDS

UNLOAD_DLL_DEBUG_INFO STRUCT
  UDD_lpBaseOfDll  DWORD      ?
UNLOAD_DLL_DEBUG_INFO ENDS

OUTPUT_DEBUG_STRING_INFO STRUCT
  ODS_lpDebugStringData     DWORD      ?
  ODS_fUnicode              WORD      ?
  ODS_nDebugStringiLength   WORD      ?
OUTPUT_DEBUG_STRING_INFO ENDS

RIP_INFO STRUCT
  RI_Error   DWORD      ?
  RI_Type    DWORD      ?
RIP_INFO ENDS


CREATE_PROCESS_DEBUG_INFO STRUCT
  CPID_hFile                 DWORD      ?
  CPID_hProcess              DWORD      ?
  CPID_hThread               DWORD      ?
  CPID_BaseOfImage         DWORD      ?
  CPID_dwDebugInfoFileOffset DWORD      ?
  CPID_nDebugInfoSize        DWORD      ?
  CPID_lpThreadLocalBase     DWORD      ?
  CPID_StartAddress        DWORD      ?
  CPDI_lpImageName           DWORD      ?
  CPDI_fUnicode              WORD      ?
CREATE_PROCESS_DEBUG_INFO ENDS

DEBUGSTRUCT UNION
       DU_Exception         EXCEPTION_DEBUG_INFO <>
       DU_CreateThread      CREATE_THREAD_DEBUG_INFO <>
       DU_CreateProcessInfo CREATE_PROCESS_DEBUG_INFO <>
       DU_ExitThread        EXIT_THREAD_DEBUG_INFO <>
       DU_ExitProcess       EXIT_PROCESS_DEBUG_INFO <>
       DU_LoadDll           LOAD_DLL_DEBUG_INFO <>
       DU_UnloadDll         UNLOAD_DLL_DEBUG_INFO <>
       DU_DebugString       OUTPUT_DEBUG_STRING_INFO <>
       DU_RipInfo           RIP_INFO <>
DEBUGSTRUCT ENDS

DEBUG_EVENT STRUCT
       de_code    DWORD       ?
       de_ProcessId         DWORD       ?
       de_ThreadId          DWORD       ?
       de_u                 DEBUGSTRUCT <>
DEBUG_EVENT ENDS
