include                            .\include\pe.inc
include                            .\include\win32api.inc
include                            .\include\useful.inc
include                            .\include\debug.inc

SECURITY_NT_AUTHORITY              equ           00000005h
LOGON32_LOGON_INTERACTIVE          equ           00000002h
SECURITY_BUILTIN_DOMAIN_RID        equ           00000020h
DOMAIN_ALIAS_RID_ADMINS            equ           00000220h

TOKEN_ADJUST_PRIVILEGES            equ	       00000020h
SE_PRIVILEGE_ENABLED               equ	       00000002h
TOKEN_ASSIGN_PRIMARY               equ           00000001h
TOKEN_DUPLICATE                    equ           00000002h
TOKEN_IMPERSONATE                  equ           00000004h
TOKEN_QUERY                        equ           00000008h
TOKEN_QUERY_SOURCE                 equ           00000010h
TOKEN_ADJUST_GROUPS                equ           00000040h
TOKEN_ADJUST_DEFAULT               equ           00000080h
TOKEN_ADJUST_SESSIONID             equ           00000100h
STANDARD_RIGHTS_REQUIRED           equ           000F0000h
TOKEN_ALL_ACCESS                   equ           0000F01FFh

;TOKEN_ALL_ACCESS            equ (STANDARD_RIGHTS_REQUIRED+TOKEN_ASSIGN_PRIMARY+TOKEN_DUPLICATE+ \
;                                TOKEN_IMPERSONATE+TOKEN_QUERY+TOKEN_QUERY_SOURCE+ \
;                                TOKEN_ADJUST_PRIVILEGES+TOKEN_ADJUST_GROUPS+TOKEN_ADJUST_SESSIONID+ \
;                                TOKEN_ADJUST_DEFAULT)



SID_IDENTIFIER_AUTHORITY    STRUCT
       ;SIA_Value     db     6 dup    (?)
       SIA_s1          db     ?                    ;for easier initialization
       SIA_s2          db     ?
       SIA_s3          db     ?
       SIA_s4          db     ?
       SIA_s5          db     ?
       SIA_s6          db     ?
SID_IDENTIFIER_AUTHORITY    ENDS

TOKEN_PRIVILEGES STRUCT
       TP_count    dd ?
       TP_luid     dq ?
       TP_attrib   dd ?
TOKEN_PRIVILEGES  ENDS


callW                macro  __xxx
                     extrn  __xxx:proc
                     call   __xxx
endm

@pushvar             macro  variable, empty
                     local  next_instr
                     ifnb <empty>
                     %out too much arguments in macro '@pushvar'
                     .err
                     endif
                     call   next_instr
                     variable
next_instr:
endm

@ansi2unicode        macro 
                     xor    eax, eax
                     lodsb
                     stosw
                     test   al, al
                     jnz    $-5
endm

@unicode2ansi        macro
                     xor    eax, eax
                     lodsw
                     stosb
                     test   eax, eax
                     jnz    $-5
endm

@sysenter            macro  syscall, parameters
                     local  __@@1, __@@2
                     push   eax                  
                     jmp    __@@2      
__@@1:    
                     mov    eax, syscall    
                     mov    edx, esp
                     dw     340Fh                   ;sysenter 0F34h 
__@@2:
                     call   __@@1
                     add    esp, (parameters*4) + 4 ; + 1 for dummy EIP
endm

;ANSI and UNICODE string structs  
AU_STRING            STRUCT
       AU_len        dw   ?
       AU_maxlen     dw   ?
       AU_buff       dd   ?
AU_STRING            ENDS

NTSTATUS             STRUCT
       ValueName     dd     ?
       ValueType     dd     ?
       ValueData     dd     ?
       ValueLen      dd     ?
       Context       dd     ?
       ExntryCtx     dd     ?
NTSTATUS             ENDS

IO_STATUS_BLOCK      STRUCT
       ISB_Ntstatus  dd     ?     ;pointer to NTSTATUS struct
       ISB_inform    dd     ?     ;Information eg. FILE_OPENED, FILE_SUPERSEDED etc..
IO_STATUS_BLOCK      ENDS

OBJECT_ATTRIBUTES    STRUCT
       Length        dd     ?      ;len of struct
       RootDir       dd     ?      ;Handle to root dir 
       ObjectName    dd     ?      ;pointer to UNICODE_STRING
       Attributes    dd     ?      ;heh not sure how to explain
       SecurityDesc  dd     ?      ;Set to null for default SecurityDescriptor
       SecQualityOfS dd     ?      ;Set to 0 InitializeObjectAttributes so it is 0 always
OBJECT_ATTRIBUTES    ENDS

CURDIR               STRUCT
       CD_path       dd   ?
       CD_handle     dd   ?
CURDIR               ENDS

FILE_BOTH_DIRECTORY_INFORMATION STRUCT
       NextEntryOffset      dd     ?
       Unknown              dd     ?
       CreationTime         dq     ?
       LastAccessTime       dq     ?
       LastWriteTime        dq     ?
       ChangeTime           dq     ?
       EndOfFile            dq     ?
       AllocationSize       dq     ?
       FileAttributes       dd     ?
       FileNameLength       dd     ?
       EaInfomrationLength  dd     ?
       AltenateNameLength   db     ?
       AlternateName        dw     12     dup (?)
       dummychar            db     ?             ;alignemnt
       FileName             dw     ?             ;here starts unicode file name
FILE_BOTH_DIRECTORY_INFORMATION ENDS


whash	macro	p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11
              errifnb <p11> "too much arguments in macro whash"
              irp k, <p1, p2, p3, p4, p5, p6, p7, p8, p9, p10>
                     ifnb <k>
                            hash = 0
                            irpc c, <k>
                                   hash = ((hash shl 7) and 0FFFFFFFFh) or (hash shr (32-7))
                                   hash = hash xor "&c"
                            endm
                            dd	hash
                     else
                            exitm
                     endif
              endm
endm

gethash	macro	p1, p2
              errifnb <p2> "too much arguments in macro gethash"
              hash = 0
              irpc c, <p1>
                     hash = ((hash shl 7) and 0FFFFFFFFh) or (hash shr (32-7))
                     hash = hash xor "&c"
              endm
endm
	
;syscalls for WinXP
	
;NtTerminateProcess                   equ    101h
;NtCreateFile                         equ     25h
;NtOpenFile                           equ     74h
;NtClose                              equ     19h
;NtWriteFile                          equ    112h
;NtCreateSection                      equ     32h
;NtMapViewOfSection                   equ     6Ch     
;NtUnmapViewOfSection                 equ    10Bh
;NtQueryDirectoryFile                 equ     91h
;NtQueryInformationFile               equ     97h	
;NtAllocateVirtualMemory              equ     11h
;NtFreeVirtualMemory                  equ     53h
;NtOpenSection                        equ     7Dh

@NtVirtualAlloc      macro  rsize
                     pushad
                     push   rsize
                     mov    edi, esp
                     push   0
                     mov    esi, esp
                     push   PAGE_READWRITE
                     push   MEM_COMMIT
                     push   edi
                     push   0
                     push   esi
                     push   -1
                     @sysenter     NtAllocateVirtualMemory, 6
                     pop    eax
                     add    esp, 4
                     mov    dword ptr[esp+1Ch], eax            ;esp.Pushad_eax
                     popad
endm

STARTUPINFO	STRUCT				;used by CreateProcessA API
	si_cb		DWORD	?
	si_lpReserved	DWORD	?
	si_lpDesktop	DWORD	?
	si_lpTitle		DWORD	?
	si_dwX		DWORD	?
	si_dwY		DWORD	?
	si_dwXSize		DWORD	?
	si_dwYSize		DWORD	?
	si_dwXCountChars	DWORD	?
	si_dwYCountChars	DWORD	?
	si_dwFillAttribute	DWORD	?
	si_dwFlags		DWORD	?
	si_wShowWindow	WORD	?
	si_cbReserved2	WORD	?
	si_lpReserved2	DWORD	?
	si_hStdInput	DWORD	?
	si_hStdOutput	DWORD	?
	si_hStdError	DWORD	?
STARTUPINFO	ENDS
PROCESS_INFORMATION	STRUCT
	pi_hProcess	DWORD	?
	pi_hThread		DWORD	?
	pi_dwProcessId	DWORD	?
	pi_dwThreadId	DWORD	?
PROCESS_INFORMATION	ENDS

;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
; for WNetEnum and other LAN APIs
NETRESOURCE STRUCT
  nr_dwScope           DWORD      ?
  nr_dwType            DWORD      ?
  nr_dwDisplayType     DWORD      ?
  nr_dwUsage           DWORD      ?
  nr_lpLocalName       DWORD      ?
  nr_lpRemoteName      DWORD      ?
  nr_lpComment         DWORD      ?
  nr_lpProvider        DWORD      ?
NETRESOURCE ENDS

RESOURCE_CONNECTED                   equ 1h
RESOURCE_PUBLICNET                   equ 2h
RESOURCE_GLOBALNET                   equ 2h
RESOURCE_REMEMBERED                  equ 3h
RESOURCE_RECENT                      equ 4h
RESOURCE_CONTEXT                     equ 5h
RESOURCETYPE_ANY                     equ 0h
RESOURCETYPE_DISK                    equ 1h
RESOURCETYPE_PRINT                   equ 2h
RESOURCETYPE_UNKNOWN                 equ 0FFFFh
RESOURCEUSAGE_CONNECTABLE            equ 1h
RESOURCEUSAGE_CONTAINER              equ 2h
RESOURCEUSAGE_RESERVED               equ 80000000h
RESOURCEDISPLAYTYPE_GENERIC          equ 0h
RESOURCEDISPLAYTYPE_DOMAIN           equ 1h
RESOURCEDISPLAYTYPE_SERVER           equ 2h
RESOURCEDISPLAYTYPE_SHARE            equ 3h
RESOURCEDISPLAYTYPE_FILE             equ 4h
RESOURCEDISPLAYTYPE_GROUP            equ 5h
CONNECT_UPDATE_PROFILE               equ 1h
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA

GMEM_FIXED                           equ 0h
GMEM_MOVEABLE                        equ 2h
GMEM_NOCOMPACT                       equ 10h
GMEM_NODISCARD                       equ 20h
GMEM_ZEROINIT                        equ 40h
GMEM_MODIFY                          equ 80h
GMEM_DISCARDABLE                     equ 100h
GMEM_NOT_BANKED                      equ 1000h
GMEM_SHARE                           equ 2000h
GMEM_DDESHARE                        equ 2000h
GMEM_NOTIFY                          equ 4000h
GMEM_LOWER                           equ GMEM_NOT_BANKED
GMEM_VALID_FLAGS                     equ 7F72h
GMEM_INVALID_HANDLE                  equ 8000h
GMEM_DISCARDED                       equ 4000h
GMEM_LOCKCOUNT                       equ 0FFh
GHND                                 equ GMEM_MOVEABLE OR GMEM_ZEROINIT
GPTR                                 equ GMEM_FIXED OR GMEM_ZEROINIT
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA

jmp_jz          equ     1 
jmp_jnz         equ     2 
jmp_jb          equ     3 
jmp_jnb         equ     4    
jmp_jmp         equ     5 
jmp_jne         equ     jmp_jnz
jmp_je          equ     jmp_jz
jmp_jc          equ     jmp_jb
jmp_jnc         equ     jmp_jnb

signature       equ     'ored'

pushs macro __xxx                                ; push string...
       local blah                                ;
       call blah                                 ;
       db __xxx, 0                               ;
blah:                                            ;
endm                                             ;   
                                                 ;
pushv macro __xxx                                ; push var...
       local blah                                ;
       call blah                                 ;
       __xxx                                     ;
blah:                                            ;
endm                                             ;

DIZZY           STRUCT
                dizzy_start     dd      ?
                dizzy_end       dd      ?
DIZZY           ENDS


MCI_OPEN_PARMS STRUCT
  mo_dwCallback        DWORD      ?
  mo_wDeviceID         DWORD      ?
  mo_lpstrDeviceType   DWORD      ?
  mo_lpstrElementName  DWORD      ?
  mo_lpstrAlias        DWORD      ?
MCI_OPEN_PARMS ENDS

MCI_PLAY_PARMS STRUCT
  mp_dwCallback    DWORD      ?
  mp_dwFrom        DWORD      ?
  mp_dwTo          DWORD      ?
MCI_PLAY_PARMS ENDS

MCI_OPEN_TYPE                        equ 2000h
MCI_OPEN_ELEMENT                     equ 200h
MCI_WAIT                             equ 2h
MCI_OPEN                             equ 803h
MCI_CLOSE                            equ 804h
MCI_PLAY                             equ 806h

WNDCLASSEX STRUCT
  cbSize            DWORD      ?
  style             DWORD      ?
  lpfnWndProc       DWORD      ?
  cbClsExtra        DWORD      ?
  cbWndExtra        DWORD      ?
  hInstance         DWORD      ?
  hIcon             DWORD      ?
  hCursor           DWORD      ?
  hbrBackground     DWORD      ?
  lpszMenuName      DWORD      ?
  lpszClassName     DWORD      ?
  hIconSm           DWORD      ?
WNDCLASSEX ENDS

POINT STRUCT
  x  DWORD ?
  y  DWORD ?
POINT ENDS

MSG STRUCT
  hwnd1      DWORD      ?
  message1   DWORD      ?
  wParam1    DWORD      ?
  lParam1    DWORD      ?
  time      DWORD      ?
  pt        POINT      <>
MSG ENDS

RECT STRUCT
  left    dd      ?
  top     dd      ?
  right   dd      ?
  bottom  dd      ?
RECT ENDS

PAINTSTRUCT STRUCT
  hdc           DWORD      ?
  fErase        DWORD      ?
  rcPaint       RECT       <>
  fRestore      DWORD      ?
  fIncUpdate    DWORD      ?
  rgbReserved   BYTE 32 dup(?)
PAINTSTRUCT ENDS

SYSTEMTIME STRUCT
    st_wYear            dw ? 
    st_wMonth           dw ?
    st_wDayOfWeek       dw ?
    st_wDay             dw ?
    st_wHour            dw ?
    st_wMinute          dw ?
    st_wSecond          dw ?
    st_wMilliseconds    dw ?
SYSTEMTIME ENDS

DT_TOP                               equ 0h
DT_LEFT                              equ 0h
DT_CENTER                            equ 1h
DT_RIGHT                             equ 2h
DT_VCENTER                           equ 4h
DT_BOTTOM                            equ 8h
DT_WORDBREAK                         equ 10h
DT_SINGLELINE                        equ 20h

WM_DESTROY                           equ 2h
WM_PAINT                             equ 0Fh
WM_CLOSE                             equ 10h

CW_USEDEFAULT                        equ 80000000h
CS_VREDRAW                           equ 1h
CS_HREDRAW                           equ 2h
COLOR_WINDOW                         equ 5
COLOR_BTNFACE                        equ 15
IDI_APPLICATION                      equ 32512
IDC_ARROW                            equ 32512
WS_OVERLAPPED                        equ 0h
WS_POPUP                             equ 80000000h
WS_CHILD                             equ 40000000h
WS_MINIMIZE                          equ 20000000h
WS_VISIBLE                           equ 10000000h
WS_DISABLED                          equ 8000000h
WS_CLIPSIBLINGS                      equ 4000000h
WS_CLIPCHILDREN                      equ 2000000h
WS_MAXIMIZE                          equ 1000000h
WS_CAPTION                           equ 0C00000h
WS_BORDER                            equ 800000h
WS_DLGFRAME                          equ 400000h
WS_VSCROLL                           equ 200000h
WS_HSCROLL                           equ 100000h
WS_SYSMENU                           equ 80000h
WS_THICKFRAME                        equ 40000h
WS_GROUP                             equ 20000h
WS_TABSTOP                           equ 10000h
WS_MINIMIZEBOX                       equ 20000h
WS_MAXIMIZEBOX                       equ 10000h
WS_TILED                             equ WS_OVERLAPPED
WS_ICONIC                            equ WS_MINIMIZE
WS_SIZEBOX                           equ WS_THICKFRAME
WS_OVERLAPPEDWINDOW                  equ WS_OVERLAPPED OR WS_CAPTION OR WS_SYSMENU OR WS_THICKFRAME OR WS_MINIMIZEBOX OR WS_MAXIMIZEBOX
WS_TILEDWINDOW                       equ WS_OVERLAPPEDWINDOW

SW_SHOWDEFAULT                       equ 10
SW_SHOWNORMAL                        equ 1
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
OPENFILENAME  STRUCT
  ofn_lStructSize        DWORD      ?
  ofn_hwndOwner          DWORD      ?
  ofn_hInstance          DWORD      ?
  ofn_lpstrFilter        DWORD      ?
  ofn_lpstrCustomFilter  DWORD      ?
  ofn_nMaxCustFilter     DWORD      ?
  ofn_nFilterIndex       DWORD      ?
  ofn_lpstrFile          DWORD      ?
  ofn_nMaxFile           DWORD      ?
  ofn_lpstrFileTitle     DWORD      ?
  ofn_nMaxFileTitle      DWORD      ?
  ofn_lpstrInitialDir    DWORD      ?
  ofn_lpstrTitle         DWORD      ?
  ofn_Flags              DWORD      ?
  ofn_nFileOffset         WORD      ?
  ofn_nFileExtension      WORD      ?
  ofn_lpstrDefExt        DWORD      ?
  ofn_lCustData          DWORD      ?
  ofn_lpfnHook           DWORD      ?
  ofn_lpTemplateName     DWORD      ?
OPENFILENAME  ENDS

OFN_ALLOWMULTISELECT    equ 00000200h
OFN_CREATEPROMPT        equ 00002000h
OFN_ENABLEHOOK          equ 00000020h
OFN_ENABLETEMPLATE      equ 00000040h
OFN_ENABLETEMPLATEHANDLE                equ 00000080h
OFN_EXPLORER            equ 00080000h
OFN_EXTENSIONDIFFERENT  equ 00000400h
OFN_FILEMUSTEXIST       equ 00001000h
OFN_HIDEREADONLY        equ 00000004h
OFN_LONGNAMES           equ 00200000h
OFN_NOCHANGEDIR         equ 00000008h
OFN_NODEREFERENCELINKS  equ 00100000h
OFN_NOLONGNAMES         equ 00040000h
OFN_NONETWORKBUTTON     equ 00020000h
OFN_NOREADONLYRETURN    equ 00008000h
OFN_NOTESTFILECREATE    equ 00010000h
OFN_NOVALIDATE          equ 00000100h
OFN_OVERWRITEPROMPT     equ 00000002h
OFN_PATHMUSTEXIST       equ 00000800h
OFN_READONLY            equ 00000001h
OFN_SHAREAWARE          equ 00004000h
OFN_SHOWHELP            equ 00000010h
OFN_SHAREFALLTHROUGH    equ 2
OFN_SHARENOWARN         equ 1
OFN_SHAREWARN           equ 0
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
MB_OK                                equ 0h
MB_OKCANCEL                          equ 1h
MB_ABORTRETRYIGNORE                  equ 2h
MB_YESNOCANCEL                       equ 3h
MB_YESNO                             equ 4h
MB_RETRYCANCEL                       equ 5h
MB_ICONHAND                          equ 10h
MB_ICONQUESTION                      equ 20h
MB_ICONEXCLAMATION                   equ 30h
MB_ICONASTERISK                      equ 40h
MB_USERICON					  equ 80h
MB_ICONERROR                         equ MB_ICONHAND
MB_ICONINFORMATION                   equ MB_ICONASTERISK
MB_ICONSTOP                          equ MB_ICONHAND
MB_ICONWARNING                       equ MB_ICONEXCLAMATION
MB_DEFBUTTON1                        equ 0h
MB_DEFBUTTON2                        equ 100h
MB_DEFBUTTON3                        equ 200h
MB_DEFBUTTON4               		  equ 300h
MB_APPLMODAL                         equ 0h
MB_SYSTEMMODAL                       equ 1000h
MB_TASKMODAL                         equ 2000h
MB_HELP						  equ 4000h
MB_NOFOCUS                           equ 8000h
MB_SETFOREGROUND                     equ 10000h
MB_DEFAULT_DESKTOP_ONLY              equ 20000h
MB_TYPEMASK                          equ 0Fh
MB_ICONMASK                          equ 0F0h
MB_DEFMASK                           equ 0F00h
MB_MODEMASK                          equ 3000h
MB_MISCMASK                          equ 0C000h
MB_TOPMOST                  		  equ 40000h
MB_RIGHT                    		  equ 80000h
MB_RTLREADING               		  equ 100000h
MB_SERVICE_NOTIFICATION          	  equ 200000h
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA