.586p                                            ;
.model flat, stdcall                             ;
locals                                           ;
jumps                                            ;
                                                 ;
include       shitheap.inc                       ;
                                                 ;
.data                                            ;
sinfo         STARTUPINFO          <0>           ;
pinfo         PROCESS_INFORMATION  <0>           ;
de            DEBUG_EVENT          <0>           ;
ctx           CONTEXT              <0>           ;
ldt           LDT_ENTRY            <0>           ;
ofn           OPENFILENAME         <0>           ;
imagebase     dd     ?                           ; image base (400000)
imagesize     dd     ?                           ; image size (SizeOfImage)
imageend      dd     ?                           ; image base + image size
first         dd     0                           ;
oldp          dd     ?                           ;
opcode        dd     ?                           ;
byte4         dd     ?                           ;
buffer        db     1024 dup(0)                 ;
pehdr         db     1024 dup(0)                 ; for PE analyzing of process
fname         db     512 dup(0)                  ; fname...
Filter        db     "Executable Files",0,"*.exe",0 ; filter string...
.code                                            ;
__start:                                         ;
       mov ofn.ofn_lStructSize,size OPENFILENAME ; 
       mov ofn.ofn_lpstrFilter, offset Filter    ; 
       mov ofn.ofn_lpstrFile, offset fname       ; 
       mov ofn.ofn_nMaxFile,512                  ;
       mov ofn.ofn_Flags, OFN_FILEMUSTEXIST or \ ;
                          OFN_PATHMUSTEXIST or \ ;
                          OFN_LONGNAMES or     \ ;
                          OFN_EXPLORER or      \ ;
                          OFN_HIDEREADONLY       ;
       push offset ofn                           ;
       callW GetOpenFileNameA                    ;
       test eax, eax                             ;
       jz error                                  ;
                                                 ;
       push offset pinfo                         ;
       push offset sinfo                         ;
       push 0                                    ;
       push 0                                    ;
       push DEBUG_ONLY_THIS_PROCESS + DEBUG_PROCESS ;
       push 0                                    ;
       push 0                                    ;
       push 0                                    ;
       push 0                                    ;
       push offset fname                         ; 
       callW CreateProcessA                      ; create process for 
       test eax, eax                             ; debuging
       jz error                                  ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
begin_dbg:                                       ;
                                                 ;
       push -1                                   ; infinite
       push offset de                            ; addr of debug_event struct
       callW WaitForDebugEvent                   ; wait for debug event
                                                 ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
       cmp de.de_code, CREATE_PROCESS_DEBUG_EVENT;
       jne __skip1                               ;
                                                 ;
                                                 ;
       push de.de_u.CPID_BaseOfImage             ;
       pop imagebase                             ;
                                                 ;
                                                 ;
       call AnalyzePE                            ;
                                                 ;
       push offset oldp                          ;
       push PAGE_READWRITE                       ;
       push imagesize                            ;
       push imagebase                            ;
       push pinfo.pi_hProcess                    ;
       callW VirtualProtectEx                    ;
                                                 ;
       push de.de_u.CPID_StartAddress            ;
       call insert_int3h_arg4                    ;
                                                 ;
                                                 ;
       jmp continue_dbg                          ;
                                                 ;
__skip1:                                         ;
       cmp de.de_code, EXIT_PROCESS_DEBUG_EVENT  ; 
       je done_dbg                               ;
       cmp de.de_code, RIP_EVENT                 ;
       je done_dbg                               ;
                                                 ;
__skip2:                                         ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
       cmp de.de_code, EXCEPTION_DEBUG_EVENT     ; process exceptions...
       jne __skip3                               ; no exception? check next posibility
       cmp de.de_u.ER_ExceptionCode, EXCEPTION_SINGLE_STEP; check if singlstep 
       je process_single_step                    ;
                                                 ;
       cmp de.de_u.ER_ExceptionCode, EXCEPTION_BREAKPOINT;
       jne other_exceptions                      ; nah, not int 3h...
       cmp first, 0                              ; 1st int3h?
       jne restore_and_set                       ;
       mov first, 1                              ;
       call HideDebugger                         ; hide debugger from process
       jmp continue_dbg                          ;
                                                 ;
restore_and_set:                                 ; if this is mine int 3h then -
       call restore_opcode                       ; restore original opcode
       call set_tf                               ;
       call dump_instruction                     ;
       jmp continue_dbg                          ; and continue debuging
                                                 ;
process_single_step:                             ; processing single step
       call check_range                          ; check range (in ImageSize range)
       jb clear_and_insert                       ; if not in range... 
       call set_tf                               ; set TRAP flag
       call dump_instruction                     ; and dump HEX of instruction... 
       call check_prefix                         ; check_prefix F3/F2/loop
       jmp continue_dbg                          ;
                                                 ;
clear_and_insert:                                ; out of ragnge...
       call insert_int3h                         ; insert int 3h...at right place
       call clear_tf                             ;
       jmp continue_dbg                          ;
                                                 ;
other_exceptions:                                ;
       call trace_exception                      ; set BP in exception handle...
                                                 ;
       push DBG_EXCEPTION_NOT_HANDLED            ;
       push pinfo.pi_dwThreadId                  ;
       push pinfo.pi_dwProcessId                 ;
       callW ContinueDebugEvent                  ;
       jmp begin_dbg                             ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
                                                 ;
__skip3:                                         ;
       cmp de.de_code, OUTPUT_DEBUG_STRING_EVENT ;
       jne __skip4                               ;
                                                 ;
       movzx eax,de.de_u.ODS_nDebugStringiLength ; get len of output string
       push eax                                  ;
       push de.de_u.ODS_lpDebugStringData        ; get address of output string
       call get_buffer                           ; and get string from debuggy
       cmp de.de_u.ODS_fUnicode, 0               ; is it unicode?
       je print_dbg_string                       ; 
       mov esi, offset buffer                    ;
       mov edi, offset buffer                    ;
       @unicode2ansi                             ; conver it ti ANSI
                                                 ;
print_dbg_string:                                ;
       pushs <"++ OutputDebugString :">          ; 
       call stdout                               ;
       push offset buffer                        ; print string
       call stdout                               ;
       pushv <db 13, 10, 0>                      ; cr lf
       call stdout                               ; 
       jmp continue_dbg                          ; and continue debugging...
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA       
__skip4:                                         ;
continue_dbg:                                    ;
       push DBG_CONTINUE                         ; continue_dbg
       push pinfo.pi_dwThreadId                  ; Id of thread
       push pinfo.pi_dwProcessId                 ; Id of process
       callW ContinueDebugEvent                  ; and continue debug event
       jmp begin_dbg                             ; go to WaitForDebugEvent
                                                 ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
done_dbg:                                        ;
       pushs <"Debuggy has exited",13,10>        ;
       call stdout                               ;
       push pinfo.pi_hThread                     ;
       callW CloseHandle                         ;
       push pinfo.pi_hProcess                    ;
       callW CloseHandle                         ;
                                                 ;
exit:                                            ;
       push 0                                    ;
       callW ExitProcess                         ;
                                                 ;
error:                                           ;
       push 0                                    ;
       pushs <"error dude">                      ;
       pushs <"Select some file plz...">         ;
       push 0                                    ;
       callW MessageBoxA                         ;
       jmp exit                                  ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
;dump output to console
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
stdout proc                                      ;
extern GetStdHandle:proc                         ;
extern WriteFile:proc                            ;
       pushad                                    ;
       call GetStdHandle, -11                    ;
       mov ebx, eax                              ;
       mov esi, [esp+8*4+4]                      ;
       push esi                                  ;
__strlen:                                        ;
       lodsb                                     ;
       test al, al                               ;
       jnz __strlen                              ;
       pop edi                                   ;
       sub esi, edi                              ;
       dec esi                                   ;
       call WriteFile, ebx, edi, esi, esp, 0     ;
       popad                                     ;
       ret 4                                     ;
stdout endp                                      ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
;Set TF flag for single step...
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
set_tf proc                                      ;
       pushad                                    ;
       call get_ctx                              ;
                                                 ;
       or ctx.CONTEXT_EFlags, 100h               ;
                                                 ;
       call set_ctx                              ;
       popad                                     ;
       ret                                       ;
set_tf endp                                      ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
;clear_tf...
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
clear_tf proc                                    ;
       pushad                                    ;
       call get_ctx                              ;
                                                 ;
       and ctx.CONTEXT_EFlags, 0FFFFFEFFh        ;
                                                 ;
       call set_ctx                              ;
       popad                                     ;
       ret                                       ;
clear_tf endp                                    ;       
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
;dump HEX of instruction...
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
dump_instruction proc                            ;
       pushad                                    ;
       call get_ctx                              ;
       test eax, eax                             ;
       jz end_dump                               ;
                                                 ;
       push 0                                    ;
       push 16                                   ;
       push offset instr                         ;
       push ctx.CONTEXT_Eip                      ;
       push pinfo.pi_hProcess                    ;
       callW ReadProcessMemory                   ;
                                                 ;
                                                 ;
       push ctx.CONTEXT_Eip                      ;
       pushs <"EIP : 0x%0.8X ->> ">              ;
       push offset buffer                        ;
       callW _wsprintfA                          ;
       add esp, 12                               ;
       push offset buffer                        ;
       call stdout                               ;
                                                 ;
       push offset instr                         ;
       call ldex86                               ;
                                                 ;
       mov esi, offset instr                     ;
       mov ecx, eax                              ;
                                                 ;
loop_dump:                                       ;
       push ecx                                  ;
       movzx eax, byte ptr[esi]                  ;
       push eax                                  ;
       pushs <"%.2X ">                           ;
       push offset buffer                        ;
       callW _wsprintfA                          ;
       add esp, 12                               ;
       push offset buffer                        ;
       call stdout                               ;
       pop ecx                                   ;
       inc esi                                   ;
       loop loop_dump                            ;
                                                 ;
       pushs <13,10>                             ;
       call stdout                               ;
                                                 ;
end_dump:                                        ;
       popad                                     ;
       ret                                       ;           
dump_instruction endp                            ;
instr  db     16 dup (0)                         ; 
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
;insert_int3h ...
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
insert_int3h proc                                ;
       pushad                                    ;
       call get_ctx                              ;
                                                 ;
       mov esi, ctx.CONTEXT_Esp                  ; here is stored EIP
       push 0                                    ; (ret address) so I have
       push 4                                    ; to get it before
       pushv <temp_eip dd ?>                     ; I can insert int3h...
       push esi                                  ; 
       push pinfo.pi_hProcess                    ;
       callW ReadProcessMemory                   ;
                                                 ;
       push 0                                    ; and now get byte
       push 4                                    ; from that address...
       push offset opcode                        ;
       push temp_eip                             ;
       push pinfo.pi_hProcess                    ;
       callW ReadProcessMemory                   ;
                                                 ;
       push 0                                    ;
       push 1                                    ;
       pushv <db 0CCh>                           ;
       push temp_eip                             ;
       push pinfo.pi_hProcess                    ;
       callW WriteProcessMemory                  ;
                                                 ;
       popad                                     ;
       ret                                       ;
insert_int3h endp                                ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
; insert_int3h_arg4 ... inserts int3h at specified location...
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
insert_int3h_arg4 proc address:dword             ;
       push 0                                    ;
       push 4                                    ;
       push offset opcode                        ;
       push address                              ;
       push pinfo.pi_hProcess                    ;
       callW ReadProcessMemory                   ;
                                                 ;
       push 0                                    ;
       push 1                                    ;
       pushv <db 0CCh>                           ;
       push address                              ;
       push pinfo.pi_hProcess                    ;
       callW WriteProcessMemory                  ;
       ret                                       ;
insert_int3h_arg4 endp                           ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
; restore_opcode ... restores opcode when int3h occurs...
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
restore_opcode proc                              ;
       call get_ctx                              ;
                                                 ;
       dec ctx.CONTEXT_Eip                       ;
                                                 ;
       push 0                                    ;
       push 4                                    ;
       push offset opcode                        ;
       push ctx.CONTEXT_Eip                      ;
       push pinfo.pi_hProcess                    ;
       callW WriteProcessMemory                  ;
                                                 ;
       call set_ctx                              ;
       ret                                       ;
restore_opcode endp                              ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
;AnalyzePE... analyzes PE header for needed stuff...
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AnalyzePE proc                                   ;
       pushad                                    ;
       push 0                                    ;
       push 1024                                 ;
       push offset pehdr                         ;
       push imagebase                            ;
       push pinfo.pi_hProcess                    ;
       callW ReadProcessMemory                   ;
                                                 ;
       mov ebx, offset pehdr                     ;
       add ebx, dword ptr[ebx+3Ch]               ;
       mov eax, [ebx.NT_OptionalHeader.OH_SizeOfImage] ;
       mov imagesize, eax                        ;
       add eax, imagebase                        ;
       mov imageend, eax                         ;
       popad                                     ;
       ret                                       ;
AnalyzePE endp                                   ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
;check_range ... CF if out of range...
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
check_range proc                                 ;
       call get_ctx                              ;
                                                 ;
       mov eax, imageend                         ;
       cmp eax, ctx.CONTEXT_Eip                  ; CF if eax is smaller
                                                 ;
       ret                                       ;
check_range endp                                 ; 
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
;avoid repets of F2/F3 prefixes...
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
check_prefix proc                                ;      
       call get_ctx                              ;
                                                 ;
       push 0                                    ;
       push 16                                   ;
       push offset temp_instr                    ;
       push ctx.CONTEXT_Eip                      ;
       push pinfo.pi_hProcess                    ;
       callW ReadProcessMemory                   ;
                                                 ;
       mov esi, offset temp_instr                ;
       cmp byte ptr[esi], 0F2h                   ;
       je _prefix                                ;
       cmp byte ptr[esi], 0F3h                   ;
       ;je _prefix                               ;
       ;cmp byte ptr[esi], 0E2h                  ;
       jne _no_prefix                            ;
                                                 ;
_prefix:                                         ;
       push esi                                  ;
       call ldex86                               ;
       mov esi,ctx.CONTEXT_Eip                   ;
       add esi, eax                              ;
       push esi                                  ;
       call insert_int3h_arg4                    ;
       call clear_tf                             ;
                                                 ;
_no_prefix:                                      ;
       ret                                       ;
check_prefix endp                                ;
temp_instr    db 16 dup (0)                      ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
;get_byte4...
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
get_byte4 proc address:dword                     ;
       pushad                                    ;
       push 0                                    ;
       push 4                                    ;
       push offset byte4                         ;
       push address                              ;
       push pinfo.pi_hProcess                    ;
       callW ReadProcessMemory                   ;
       popad                                     ;
       ret                                       ;
get_byte4 endp                                   ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
store_byte4 proc address:dword                   ;
       pushad                                    ;
       push 0                                    ;
       push 4                                    ;
       push offset byte4                         ;
       push address                              ;
       push pinfo.pi_hProcess                    ;
       callW WriteProcessMemory                  ;
       popad                                     ;
       ret                                       ;
store_byte4 endp                                 ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
;trace_exception... 
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
trace_exception proc                             ;
       call get_ctx                              ;
                                                 ;
       push offset ldt                           ;
       push ctx.CONTEXT_SegFs                    ;
       push pinfo.pi_hThread                     ;
       callW GetThreadSelectorEntry              ;
                                                 ;
       mov ah, ldt.ldt_BaseHi                    ;
       mov al, ldt.ldt_BaseMid                   ;
       shl eax, 16                               ;
       mov ax, ldt.ldt_BaseLow                   ;
                                                 ;
       push eax                                  ;
       call get_byte4                            ; get FS:[0]
       mov eax, byte4                            ; 
       add eax, 4                                ; eax = addr of sehhandle
       push eax                                  ; 
       call get_byte4                            ; and get address of sehhnadle
                                                 ;
       push byte4                                ;
       call insert_int3h_arg4                    ;
       call clear_tf                             ;
                                                 ;    
       ret                                       ;
trace_exception endp                             ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
;hide_debugger - tries to avoid IsDebuggerPresent
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
HideDebugger proc                                ;
       call get_ctx                              ;
                                                 ;
       push offset ldt                           ;
       push ctx.CONTEXT_SegFs                    ;
       push pinfo.pi_hThread                     ;
       callW GetThreadSelectorEntry              ;
                                                 ;
       mov ah, ldt.ldt_BaseHi                    ;
       mov al, ldt.ldt_BaseMid                   ;
       shl eax, 16                               ;
       mov ax, ldt.ldt_BaseLow                   ;
                                                 ;
       add eax, 30h                              ;                                           
       push eax                                  ;
       call get_byte4                            ; get address of PEB...
       mov eax, byte4                            ;
       push byte4                                ;
       call get_byte4                            ; get 4 bytes from PEB
       and byte4, 0FF00FFFFh                     ; and clear BeingDebugged flag...
       push eax                                  ;
       call store_byte4                          ;
       ret                                       ;
HideDebugger endp                                ; 
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
;get_buffer ... nsize can't be larger than 1024
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
get_buffer proc address:dword, nsize:dword       ;
       push 0                                    ;
       push nsize                                ;
       push offset buffer                        ;
       push address                              ;
       push pinfo.pi_hProcess                    ;
       callW ReadProcessMemory                   ;
       ret                                       ;
get_buffer endp                                  ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
;get_ctx...
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
get_ctx proc                                     ;
       mov ctx.CONTEXT_ContextFlags, CONTEXT_FULL;
       push offset ctx                           ;
       push pinfo.pi_hThread                     ;
       callW GetThreadContext                    ;
       ret                                       ;
get_ctx endp                                     ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
;set_ctx                                  
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
set_ctx proc                                     ;
       push offset ctx                           ;
       push pinfo.pi_hThread                     ;
       callW SetThreadContext                    ;
       ret                                       ;
set_ctx endp                                     ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
; ldex86 - length decoder engine...
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
include ldex86bin.inc                            ;
;AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA       
end __start                                      ;
